package dev.shadowsoffire.apotheosis.garden;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import dev.shadowsoffire.apotheosis.garden.GardenModule;
import dev.shadowsoffire.placebo.util.IReplacementBlock;
import net.minecraft.core.BlockPos;
import net.minecraft.server.level.ServerLevel;
import net.minecraft.util.RandomSource;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.block.Block;
import net.minecraft.world.level.block.Blocks;
import net.minecraft.world.level.block.CactusBlock;
import net.minecraft.world.level.block.state.BlockBehaviour;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraft.world.level.block.state.StateDefinition;
import net.minecraft.world.level.block.state.properties.Property;
import net.minecraftforge.common.ForgeHooks;

public class ApothCactusBlock extends CactusBlock implements IReplacementBlock {
  protected StateDefinition<Block, BlockState> container;
  
  public ApothCactusBlock() {
    super(BlockBehaviour.Properties.m_60926_((BlockBehaviour)Blocks.f_50128_));
  }
  
  public void m_213898_(BlockState state, ServerLevel world, BlockPos pos, RandomSource random) {
    BlockPos blockpos = pos.m_7494_();
    if (!world.m_151570_(blockpos) && world.m_46859_(blockpos)) {
      int i = 1;
      if (GardenModule.maxCactusHeight <= 32)
        for (; world.m_8055_(pos.m_6625_(i)).m_60734_() == this; i++); 
      if (i < GardenModule.maxCactusHeight) {
        int j = ((Integer)state.m_61143_((Property)f_51131_)).intValue();
        if (ForgeHooks.onCropsGrowPre((Level)world, blockpos, state, true)) {
          if (j == 15) {
            world.m_46597_(blockpos, m_49966_());
            BlockState newState = (BlockState)state.m_61124_((Property)f_51131_, Integer.valueOf(0));
            world.m_7731_(pos, newState, 4);
            world.m_213960_(newState, blockpos, (Block)this, pos, false);
          } else {
            world.m_7731_(pos, (BlockState)state.m_61124_((Property)f_51131_, Integer.valueOf(j + 1)), 4);
          } 
          ForgeHooks.onCropsGrowPost((Level)world, pos, state);
        } 
      } 
    } 
  }
  
  public void _setDefaultState(BlockState state) {
    m_49959_(state);
  }
  
  public void setStateContainer(StateDefinition<Block, BlockState> container) {
    this.container = container;
  }
  
  public StateDefinition<Block, BlockState> m_49965_() {
    return (this.container == null) ? super.m_49965_() : this.container;
  }
}
